diff --git a/dlls/dinput/ansi.c b/dlls/dinput/ansi.c
new file mode 100644
index 00000000000..edfbfb878cd
--- /dev/null
+++ b/dlls/dinput/ansi.c
@@ -0,0 +1,562 @@
+/*
+ * Ansi interface wrappers
+ *
+ * Copyright 2020 Rémi Bernon for CodeWeavers
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#include <stdarg.h>
+#include <string.h>
+
+#include "windef.h"
+#include "winbase.h"
+#include "winreg.h"
+#include "winuser.h"
+#include "winerror.h"
+#include "dinput.h"
+
+#include "device_private.h"
+#include "dinput_private.h"
+
+#include "wine/debug.h"
+
+WINE_DEFAULT_DEBUG_CHANNEL(dinput);
+
+static IDirectInputDeviceImpl *impl_from_IDirectInputDevice8A(IDirectInputDevice8A *iface)
+{
+    return CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8A_iface);
+}
+static IDirectInputDevice8W *IDirectInputDevice8W_from_impl(IDirectInputDeviceImpl *This)
+{
+    return &This->IDirectInputDevice8W_iface;
+}
+
+static void dideviceobjectinstance_wtoa(const DIDEVICEOBJECTINSTANCEW *didoiw, DIDEVICEOBJECTINSTANCEA *didoia)
+{
+    didoia->guidType = didoiw->guidType;
+    didoia->dwOfs = didoiw->dwOfs;
+    didoia->dwType = didoiw->dwType;
+    didoia->dwFlags = didoiw->dwFlags;
+    WideCharToMultiByte(CP_ACP, 0, didoiw->tszName, -1, didoia->tszName, sizeof(didoia->tszName), NULL, NULL);
+    if (didoia->dwSize <= FIELD_OFFSET(DIDEVICEOBJECTINSTANCEA, dwFFMaxForce)) return;
+    didoia->dwFFMaxForce = didoiw->dwFFMaxForce;
+    didoia->dwFFForceResolution = didoiw->dwFFForceResolution;
+    didoia->wCollectionNumber = didoiw->wCollectionNumber;
+    didoia->wDesignatorIndex = didoiw->wDesignatorIndex;
+    didoia->wUsagePage = didoiw->wUsagePage;
+    didoia->wUsage = didoiw->wUsage;
+    didoia->dwDimension = didoiw->dwDimension;
+    didoia->wExponent = didoiw->wExponent;
+    didoia->wReserved = didoiw->wReserved;
+}
+
+static void dideviceinstance_wtoa(const DIDEVICEINSTANCEW *didiw, DIDEVICEINSTANCEA *didia)
+{
+    didia->guidInstance = didiw->guidInstance;
+    didia->guidProduct = didiw->guidProduct;
+    didia->dwDevType = didiw->dwDevType;
+    WideCharToMultiByte(CP_ACP, 0, didiw->tszInstanceName, -1, didia->tszInstanceName, sizeof(didia->tszInstanceName), NULL, NULL);
+    WideCharToMultiByte(CP_ACP, 0, didiw->tszProductName, -1, didia->tszProductName, sizeof(didia->tszProductName), NULL, NULL);
+    if (didia->dwSize <= FIELD_OFFSET(DIDEVICEINSTANCEA, guidFFDriver)) return;
+    didia->guidFFDriver = didiw->guidFFDriver;
+    didia->wUsagePage = didiw->wUsagePage;
+    didia->wUsage = didiw->wUsage;
+}
+
+static void dieffectinfo_wtoa(const DIEFFECTINFOW *dieiw, DIEFFECTINFOA *dieia)
+{
+    dieia->guid = dieiw->guid;
+    dieia->dwEffType = dieiw->dwEffType;
+    dieia->dwStaticParams = dieiw->dwStaticParams;
+    dieia->dwDynamicParams = dieiw->dwDynamicParams;
+    WideCharToMultiByte(CP_ACP, 0, dieiw->tszName, -1, dieia->tszName, sizeof(dieia->tszName), NULL, NULL);
+}
+
+static WCHAR *string_atow(const char *str)
+{
+    WCHAR *strw;
+    int len;
+    if (!str) return NULL;
+    len = MultiByteToWideChar(CP_ACP, 0, str, -1, NULL, 0);
+    strw = HeapAlloc(GetProcessHeap(), 0, len * sizeof(WCHAR));
+    MultiByteToWideChar(CP_ACP, 0, str, -1, strw, len);
+    return strw;
+}
+
+static void diactionformat_wtoa(const DIACTIONFORMATW *diafw, DIACTIONFORMATA *diafa)
+{
+    DWORD i;
+    if (diafa->dwActionSize != sizeof(DIACTIONA))
+    {
+        FIXME("Unsupported action format size\n");
+        return;
+    }
+    diafa->dwDataSize = diafw->dwDataSize;
+    diafa->dwNumActions = diafw->dwNumActions;
+    for (i = 0; i < diafw->dwNumActions; ++i)
+    {
+        diafa->rgoAction[i].uAppData = diafw->rgoAction[i].uAppData;
+        diafa->rgoAction[i].dwSemantic = diafw->rgoAction[i].dwSemantic;
+        diafa->rgoAction[i].dwFlags = diafw->rgoAction[i].dwFlags;
+        diafa->rgoAction[i].guidInstance = diafw->rgoAction[i].guidInstance;
+        diafa->rgoAction[i].dwObjID = diafw->rgoAction[i].dwObjID;
+        diafa->rgoAction[i].dwHow = diafw->rgoAction[i].dwHow;
+    }
+    diafa->guidActionMap = diafw->guidActionMap;
+    diafa->dwGenre = diafw->dwGenre;
+    diafa->dwBufferSize = diafw->dwBufferSize;
+    diafa->lAxisMin = diafw->lAxisMin;
+    diafa->lAxisMax = diafw->lAxisMax;
+    diafa->hInstString = diafw->hInstString;
+    diafa->ftTimeStamp = diafw->ftTimeStamp;
+    diafa->dwCRC = diafw->dwCRC;
+    WideCharToMultiByte(CP_ACP, 0, diafw->tszActionMap, -1, diafa->tszActionMap, sizeof(diafa->tszActionMap), NULL, NULL);
+}
+
+static void diactionformat_atow(const DIACTIONFORMATA *diafa, DIACTIONFORMATW *diafw)
+{
+    DWORD i;
+    if (diafa->dwActionSize != sizeof(DIACTIONA))
+    {
+        FIXME("Unsupported action format size\n");
+        return;
+    }
+    diafw->dwDataSize = diafa->dwDataSize;
+    diafw->dwNumActions = diafa->dwNumActions;
+    for (i = 0; i < diafw->dwNumActions; ++i)
+    {
+        diafw->rgoAction[i].uAppData = diafa->rgoAction[i].uAppData;
+        diafw->rgoAction[i].dwSemantic = diafa->rgoAction[i].dwSemantic;
+        diafw->rgoAction[i].dwFlags = diafa->rgoAction[i].dwFlags;
+        diafw->rgoAction[i].guidInstance = diafa->rgoAction[i].guidInstance;
+        diafw->rgoAction[i].dwObjID = diafa->rgoAction[i].dwObjID;
+        diafw->rgoAction[i].dwHow = diafa->rgoAction[i].dwHow;
+    }
+    diafw->guidActionMap = diafa->guidActionMap;
+    diafw->dwGenre = diafa->dwGenre;
+    diafw->dwBufferSize = diafa->dwBufferSize;
+    diafw->lAxisMin = diafa->lAxisMin;
+    diafw->lAxisMax = diafa->lAxisMax;
+    diafw->hInstString = diafa->hInstString;
+    diafw->ftTimeStamp = diafa->ftTimeStamp;
+    diafw->dwCRC = diafa->dwCRC;
+    MultiByteToWideChar(CP_ACP, 0, diafa->tszActionMap, -1, diafw->tszActionMap, sizeof(diafw->tszActionMap) / sizeof(WCHAR));
+}
+
+static void dideviceimageinfo_wtoa(const DIDEVICEIMAGEINFOW *didiiw, DIDEVICEIMAGEINFOA *didiia)
+{
+    WideCharToMultiByte(CP_ACP, 0, didiiw->tszImagePath, -1, didiia->tszImagePath, sizeof(didiia->tszImagePath), NULL, NULL);
+    didiia->dwFlags = didiiw->dwFlags;
+    didiia->dwViewID = didiiw->dwViewID;
+    didiia->rcOverlay = didiiw->rcOverlay;
+    didiia->dwObjID = didiiw->dwObjID;
+    didiia->dwcValidPts = didiiw->dwcValidPts;
+    didiia->rgptCalloutLine[0] = didiiw->rgptCalloutLine[0];
+    didiia->rgptCalloutLine[1] = didiiw->rgptCalloutLine[1];
+    didiia->rgptCalloutLine[2] = didiiw->rgptCalloutLine[2];
+    didiia->rgptCalloutLine[3] = didiiw->rgptCalloutLine[3];
+    didiia->rgptCalloutLine[4] = didiiw->rgptCalloutLine[4];
+    didiia->rcCalloutRect = didiiw->rcCalloutRect;
+    didiia->dwTextAlign = didiiw->dwTextAlign;
+}
+
+static void dideviceimageinfoheader_wtoa(const DIDEVICEIMAGEINFOHEADERW *didiihw, DIDEVICEIMAGEINFOHEADERA *didiiha)
+{
+    DWORD i;
+    didiiha->dwSizeImageInfo = didiihw->dwSizeImageInfo;
+    didiiha->dwcViews = didiihw->dwcViews;
+    didiiha->dwcButtons = didiihw->dwcButtons;
+    didiiha->dwcAxes = didiihw->dwcAxes;
+    didiiha->dwcPOVs = didiihw->dwcPOVs;
+    didiiha->dwBufferSize = didiihw->dwBufferSize;
+    didiiha->dwBufferUsed = didiihw->dwBufferUsed;
+    for (i = 0; i < didiihw->dwBufferUsed / didiihw->dwSizeImageInfo; ++i)
+        dideviceimageinfo_wtoa((const DIDEVICEIMAGEINFOW *)((const char *)didiihw->lprgImageInfoArray + i * didiihw->dwSizeImageInfo),
+                (DIDEVICEIMAGEINFOA *)((char *)didiiha->lprgImageInfoArray + i * didiiha->dwSizeImageInfo));
+    didiiha->dwBufferUsed = didiihw->dwBufferUsed / sizeof(DIDEVICEIMAGEINFOW) * sizeof(DIDEVICEIMAGEINFOA);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_QueryInterface(IDirectInputDevice8A *iface, REFIID iid, void **out)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, iid %s, out %p.\n", iface, debugstr_guid(iid), out);
+    return IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out);
+}
+
+static ULONG STDMETHODCALLTYPE direct_input_device_a_AddRef(IDirectInputDevice8A *iface)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInputDevice8_AddRef(IDirectInputDevice8W_from_impl(This));
+}
+
+static ULONG STDMETHODCALLTYPE direct_input_device_a_Release(IDirectInputDevice8A *iface)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInputDevice8_Release(IDirectInputDevice8W_from_impl(This));
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetCapabilities(IDirectInputDevice8A *iface, DIDEVCAPS *caps)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, caps %p.\n", iface, caps);
+    return IDirectInputDevice8_GetCapabilities(IDirectInputDevice8W_from_impl(This), caps);
+}
+
+struct direct_input_device_a_enum_objects_params
+{
+    LPDIENUMDEVICEOBJECTSCALLBACKA callback;
+    void *ref;
+};
+
+static BOOL CALLBACK direct_input_device_a_enum_objects_callback(const DIDEVICEOBJECTINSTANCEW *didoiw, void *ref)
+{
+    struct direct_input_device_a_enum_objects_params *params = ref;
+    DIDEVICEOBJECTINSTANCEA didoia = {sizeof(didoia)};
+    dideviceobjectinstance_wtoa(didoiw, &didoia);
+    return params->callback(&didoia, params->ref);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_EnumObjects(IDirectInputDevice8A *iface,
+        LPDIENUMDEVICEOBJECTSCALLBACKA callback, void *ref, DWORD flags)
+{
+    struct direct_input_device_a_enum_objects_params params = {callback, ref};
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, callback %p, ref %p, flags %#x.\n", iface, callback, ref, flags);
+    if (!callback) return DIERR_INVALIDPARAM;
+    return IDirectInputDevice8_EnumObjects(IDirectInputDevice8W_from_impl(This),
+            direct_input_device_a_enum_objects_callback, &params, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetProperty(IDirectInputDevice8A *iface, REFGUID guid, DIPROPHEADER *diph)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, guid %s, diph %p.\n", iface, debugstr_guid(guid), diph);
+    return IDirectInputDevice8_GetProperty(IDirectInputDevice8W_from_impl(This), guid, diph);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_SetProperty(IDirectInputDevice8A *iface, REFGUID guid, const DIPROPHEADER *diph)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, guid %s, diph %p.\n", iface, debugstr_guid(guid), diph);
+    return IDirectInputDevice8_SetProperty(IDirectInputDevice8W_from_impl(This), guid, diph);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_Acquire(IDirectInputDevice8A *iface)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInputDevice8_Acquire(IDirectInputDevice8W_from_impl(This));
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_Unacquire(IDirectInputDevice8A *iface)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInputDevice8_Unacquire(IDirectInputDevice8W_from_impl(This));
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetDeviceData(IDirectInputDevice8A *iface, DWORD dodsize,
+        DIDEVICEOBJECTDATA *dod, DWORD *entries, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, dodsize %u, dod %p, flags %#x.\n", iface, dodsize, entries, flags);
+    return IDirectInputDevice8_GetDeviceData(IDirectInputDevice8W_from_impl(This), dodsize, dod, entries, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetDeviceState(IDirectInputDevice8A *iface, DWORD count, void *data)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, count %u, data %p.\n", iface, count, data);
+    return IDirectInputDevice8_GetDeviceState(IDirectInputDevice8W_from_impl(This), count, data);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_SetDataFormat(IDirectInputDevice8A *iface, const DIDATAFORMAT *didf)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, didf %p.\n", iface, didf);
+    return IDirectInputDevice8_SetDataFormat(IDirectInputDevice8W_from_impl(This), didf);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_SetEventNotification(IDirectInputDevice8A *iface, HANDLE event)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, event %p.\n", iface, event);
+    return IDirectInputDevice8_SetEventNotification(IDirectInputDevice8W_from_impl(This), event);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_SetCooperativeLevel(IDirectInputDevice8A *iface, HWND window, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, window %p, flags %#x.\n", iface, window, flags);
+    return IDirectInputDevice8_SetCooperativeLevel(IDirectInputDevice8W_from_impl(This), window, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetObjectInfo(IDirectInputDevice8A *iface,
+        DIDEVICEOBJECTINSTANCEA *didoi, DWORD obj, DWORD how)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    DIDEVICEOBJECTINSTANCEW didoiw = {sizeof(didoiw)};
+    HRESULT hr;
+    TRACE("iface %p, didoi %p, obj %u, how %u.\n", iface, didoi, obj, how);
+    if (!didoi) return E_POINTER;
+    if (didoi->dwSize != sizeof(DIDEVICEOBJECTINSTANCEA) && didoi->dwSize != sizeof(DIDEVICEOBJECTINSTANCE_DX3A)) return DIERR_INVALIDPARAM;
+    hr = IDirectInputDevice8_GetObjectInfo(IDirectInputDevice8W_from_impl(This), &didoiw, obj, how);
+    dideviceobjectinstance_wtoa(&didoiw, didoi);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetDeviceInfo(IDirectInputDevice8A *iface, DIDEVICEINSTANCEA *didi)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    DIDEVICEINSTANCEW didiw = {sizeof(didiw)};
+    HRESULT hr;
+    TRACE("iface %p, didoi %p.\n", iface, didi);
+    if (!didi) return E_POINTER;
+    if (didi->dwSize != sizeof(DIDEVICEINSTANCEA) && didi->dwSize != sizeof(DIDEVICEINSTANCE_DX3A)) return DIERR_INVALIDPARAM;
+    hr = IDirectInputDevice8_GetDeviceInfo(IDirectInputDevice8W_from_impl(This), &didiw);
+    dideviceinstance_wtoa(&didiw, didi);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_RunControlPanel(IDirectInputDevice8A *iface, HWND owner, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, owner %p, flags %#x.\n", iface, owner, flags);
+    return IDirectInputDevice8_RunControlPanel(IDirectInputDevice8W_from_impl(This), owner, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_Initialize(IDirectInputDevice8A *iface, HINSTANCE instance,
+        DWORD version, REFGUID guid)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, instance %p, version %#x, guid %s.\n", iface, instance, version, debugstr_guid(guid));
+    return IDirectInputDevice8_Initialize(IDirectInputDevice8W_from_impl(This), instance, version, guid);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_CreateEffect(IDirectInputDevice8A *iface, REFGUID guid,
+        const DIEFFECT *effect, LPDIRECTINPUTEFFECT *out, IUnknown *outer)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, guid %s, effect %p, out %p, outer %p.\n", iface, debugstr_guid(guid), effect, out, outer);
+    return IDirectInputDevice8_CreateEffect(IDirectInputDevice8W_from_impl(This), guid, effect, out, outer);
+}
+
+struct direct_input_device_a_enum_effects_params
+{
+    LPDIENUMEFFECTSCALLBACKA callback;
+    void *ref;
+};
+
+static BOOL CALLBACK direct_input_device_a_enum_effects_callback(const DIEFFECTINFOW *dieiw, void *ref)
+{
+    struct direct_input_device_a_enum_effects_params *params = ref;
+    DIEFFECTINFOA dieia = {sizeof(dieia)};
+    dieffectinfo_wtoa(dieiw, &dieia);
+    return params->callback(&dieia, params->ref);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_EnumEffects(IDirectInputDevice8A *iface,
+        LPDIENUMEFFECTSCALLBACKA callback, void *ref, DWORD type)
+{
+    struct direct_input_device_a_enum_effects_params params = {callback, ref};
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, callback %p, ref %p, type %d.\n", iface, callback, ref, type);
+    if (!callback) return DIERR_INVALIDPARAM;
+    return IDirectInputDevice8_EnumEffects(IDirectInputDevice8W_from_impl(This),
+            direct_input_device_a_enum_effects_callback, &params, type);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetEffectInfo(IDirectInputDevice8A *iface, DIEFFECTINFOA *diei, REFGUID guid)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    DIEFFECTINFOW dieiw = {sizeof(dieiw)};
+    HRESULT hr;
+    TRACE("iface %p, diei %p, guid %s.\n", iface, diei, debugstr_guid(guid));
+    if (!diei) return E_POINTER;
+    if (diei->dwSize != sizeof(DIEFFECTINFOA)) return DIERR_INVALIDPARAM;
+    hr = IDirectInputDevice8_GetEffectInfo(IDirectInputDevice8W_from_impl(This), &dieiw, guid);
+    dieffectinfo_wtoa(&dieiw, diei);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetForceFeedbackState(IDirectInputDevice8A *iface, DWORD *state)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, state %p.\n", iface, state);
+    return IDirectInputDevice8_GetForceFeedbackState(IDirectInputDevice8W_from_impl(This), state);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_SendForceFeedbackCommand(IDirectInputDevice8A *iface, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, flags %#x.\n", iface, flags);
+    return IDirectInputDevice8_SendForceFeedbackCommand(IDirectInputDevice8W_from_impl(This), flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_EnumCreatedEffectObjects(IDirectInputDevice8A *iface,
+        LPDIENUMCREATEDEFFECTOBJECTSCALLBACK callback, void *ref, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, callback %p, ref %p, flags %#x.\n", iface, callback, ref, flags);
+    return IDirectInputDevice8_EnumCreatedEffectObjects(IDirectInputDevice8W_from_impl(This), callback, ref, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_Escape(IDirectInputDevice8A *iface, DIEFFESCAPE *escape)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, escape %p.\n", iface, escape);
+    return IDirectInputDevice8_Escape(IDirectInputDevice8W_from_impl(This), escape);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_Poll(IDirectInputDevice8A *iface)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInputDevice8_Poll(IDirectInputDevice8W_from_impl(This));
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_SendDeviceData(IDirectInputDevice8A *iface, DWORD count,
+        const DIDEVICEOBJECTDATA *didod, DWORD *inout, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    TRACE("iface %p, count %u, didod %p, inout %p, flags %#x.\n", iface, count, didod, inout, flags);
+    return IDirectInputDevice8_SendDeviceData(IDirectInputDevice8W_from_impl(This), count, didod, inout, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_EnumEffectsInFile(IDirectInputDevice8A *iface,
+        const char *filename, LPDIENUMEFFECTSINFILECALLBACK callback, void *ref, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    WCHAR buffer[MAX_PATH], *filenamew = buffer;
+    TRACE("iface %p, filename %s, callback %p, ref %p, flags %#x.\n", iface, debugstr_a(filename), callback, ref, flags);
+    if (!filename) filenamew = NULL;
+    else MultiByteToWideChar(CP_ACP, 0, filename, -1, buffer, MAX_PATH);
+    return IDirectInputDevice8_EnumEffectsInFile(IDirectInputDevice8W_from_impl(This), filenamew, callback, ref, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_WriteEffectToFile(IDirectInputDevice8A *iface,
+        const char *filename, DWORD entries, DIFILEEFFECT *dife, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    WCHAR buffer[MAX_PATH], *filenamew = buffer;
+    TRACE("iface %p, filename %s, entries %u, dife %p, flags %#x.\n", iface, debugstr_a(filename), entries, dife, flags);
+    if (!filename) filenamew = NULL;
+    else MultiByteToWideChar(CP_ACP, 0, filename, -1, buffer, MAX_PATH);
+    return IDirectInputDevice8_WriteEffectToFile(IDirectInputDevice8W_from_impl(This), filenamew, entries, dife, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_BuildActionMap(IDirectInputDevice8A *iface,
+        DIACTIONFORMATA *diaf, const char *username, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    DIACTIONFORMATW diafw = {sizeof(diafw), sizeof(DIACTIONW)};
+    HRESULT hr;
+    WCHAR *usernamew = string_atow(username);
+    TRACE("iface %p, diaf %p, username %s, flags %#x.\n", iface, diaf, debugstr_a(username), flags);
+    if (!diaf) return E_POINTER;
+    if (diaf->dwSize != sizeof(DIACTIONFORMATA)) return DIERR_INVALIDPARAM;
+    if (diaf->dwActionSize != sizeof(DIACTIONA)) return DIERR_INVALIDPARAM;
+    diafw.dwNumActions = diaf->dwNumActions;
+    diafw.rgoAction = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, diaf->dwNumActions * sizeof(DIACTIONW));
+    diactionformat_atow(diaf, &diafw);
+    hr = IDirectInputDevice8_BuildActionMap(IDirectInputDevice8W_from_impl(This), &diafw, usernamew, flags);
+    diactionformat_wtoa(&diafw, diaf);
+    HeapFree(GetProcessHeap(), 0, diafw.rgoAction);
+    HeapFree(GetProcessHeap(), 0, usernamew);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_SetActionMap(IDirectInputDevice8A *iface, DIACTIONFORMATA *diaf,
+        const char *username, DWORD flags)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    DIACTIONFORMATW diafw = {sizeof(diafw), sizeof(DIACTIONW)};
+    HRESULT hr;
+    WCHAR *usernamew = string_atow(username);
+    TRACE("iface %p, diaf %p, username %s, flags %#x.\n", iface, diaf, debugstr_a(username), flags);
+    if (!diaf) return E_POINTER;
+    if (diaf->dwSize != sizeof(DIACTIONFORMATA)) return DIERR_INVALIDPARAM;
+    if (diaf->dwActionSize != sizeof(DIACTIONA)) return DIERR_INVALIDPARAM;
+    diafw.dwNumActions = diaf->dwNumActions;
+    diafw.rgoAction = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, diaf->dwNumActions * sizeof(DIACTIONW));
+    diactionformat_atow(diaf, &diafw);
+    hr = IDirectInputDevice8_SetActionMap(IDirectInputDevice8W_from_impl(This), &diafw, usernamew, flags);
+    diactionformat_wtoa(&diafw, diaf);
+    HeapFree(GetProcessHeap(), 0, diafw.rgoAction);
+    HeapFree(GetProcessHeap(), 0, usernamew);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_device_a_GetImageInfo(IDirectInputDevice8A *iface, DIDEVICEIMAGEINFOHEADERA *didiih)
+{
+    IDirectInputDeviceImpl *This = impl_from_IDirectInputDevice8A(iface);
+    DIDEVICEIMAGEINFOHEADERW didiihw = {sizeof(didiihw), sizeof(DIDEVICEIMAGEINFOW)};
+    HRESULT hr;
+    TRACE("iface %p, didiih %p.\n", iface, didiih);
+    if (!didiih) return E_POINTER;
+    if (didiih->dwSize != sizeof(DIDEVICEIMAGEINFOHEADERA)) return DIERR_INVALIDPARAM;
+    if (didiih->dwSizeImageInfo != sizeof(DIDEVICEIMAGEINFOA)) return DIERR_INVALIDPARAM;
+    didiihw.dwBufferSize = didiih->dwBufferSize / didiih->dwSizeImageInfo * didiihw.dwSizeImageInfo;
+    didiihw.lprgImageInfoArray = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, didiihw.dwBufferSize);
+    if (!didiihw.lprgImageInfoArray) return E_OUTOFMEMORY;
+    hr = IDirectInputDevice8_GetImageInfo(IDirectInputDevice8W_from_impl(This), &didiihw);
+    dideviceimageinfoheader_wtoa(&didiihw, didiih);
+    HeapFree(GetProcessHeap(), 0, didiihw.lprgImageInfoArray);
+    return hr;
+}
+
+const IDirectInputDevice8AVtbl direct_input_device_a_vtbl =
+{
+    /*** IUnknown methods ***/
+    direct_input_device_a_QueryInterface,
+    direct_input_device_a_AddRef,
+    direct_input_device_a_Release,
+    /*** IDirectInputDeviceA methods ***/
+    direct_input_device_a_GetCapabilities,
+    direct_input_device_a_EnumObjects,
+    direct_input_device_a_GetProperty,
+    direct_input_device_a_SetProperty,
+    direct_input_device_a_Acquire,
+    direct_input_device_a_Unacquire,
+    direct_input_device_a_GetDeviceState,
+    direct_input_device_a_GetDeviceData,
+    direct_input_device_a_SetDataFormat,
+    direct_input_device_a_SetEventNotification,
+    direct_input_device_a_SetCooperativeLevel,
+    direct_input_device_a_GetObjectInfo,
+    direct_input_device_a_GetDeviceInfo,
+    direct_input_device_a_RunControlPanel,
+    direct_input_device_a_Initialize,
+    /*** IDirectInputDevice2A methods ***/
+    direct_input_device_a_CreateEffect,
+    direct_input_device_a_EnumEffects,
+    direct_input_device_a_GetEffectInfo,
+    direct_input_device_a_GetForceFeedbackState,
+    direct_input_device_a_SendForceFeedbackCommand,
+    direct_input_device_a_EnumCreatedEffectObjects,
+    direct_input_device_a_Escape,
+    direct_input_device_a_Poll,
+    direct_input_device_a_SendDeviceData,
+    /*** IDirectInputDevice7A methods ***/
+    direct_input_device_a_EnumEffectsInFile,
+    direct_input_device_a_WriteEffectToFile,
+    /*** IDirectInputDevice8A methods ***/
+    direct_input_device_a_BuildActionMap,
+    direct_input_device_a_SetActionMap,
+    direct_input_device_a_GetImageInfo
+};
